



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Delphi 的动态数组</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Delphi 的动态数组</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 16:34:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>传统的Pascal 语言其数组大小是预先确定的，当你用数组结构声明数据类型时，你必须指定数组元素的个数。专业程序员也许知道些许动态数组的实现技术，一般是采用指针，用手工分配并释放所需的内存。</p>
<p>Delphi 4中增加了非常简单的动态数组实现方法，实现过程效仿我前面讲过的动态长字符串。与长字符串一样，动态数组的内存动态分配并且引用记数，不过动态数组不支持 copy-on-write 技术。这不是个大问题，因为你可以把变量值设置为nil释放数组内存。</p>
<p>这样你就可以声明一个不指定元素个数的数组，并用SetLength 过程给数组分配一个特定大小的内存，SetLength 过程还可以改变数组大小而不影响其内容，除此外还有一些字符串过程也可用于数组，如Copy 函数。</p>
<p>以下摘录的代码突出了一点，这就是：定义数组后必须先为它分配内存，然后才能开始使用：</p>
<p>procedure TForm1.Button1Click(Sender: TObject);<br />var<br />  Array1: array of Integer;<br />begin<br />  Array1 [1] := 100; // error<br />  SetLength (Array1, 100);<br />  Array1 [99] := 100; // OK<br />  ...<br />end;<br />如果你只定义一个数组元素个数，那么索引总是从0开始。Pascal 中的普通数组既能用不为零的下标，也能用非整数的下标，但动态数组均不支持这两种下标。象普通数组一样，你可以通过Length、High和Low 函数了解到动态数组的状况，不过对于动态数组，Low 函数返回值总是0，High函数返回数组大小减1，这意味着空的动态数组其函数High返回值是-1，这是一个很怪的值，因为它比Low的返回值还小。</p>
<p>图 8.1: 例 DynArr 窗体</p>
<p>以上作了简短的介绍，现在举个简例，例名DynArr ，见图8.1。例子实在是很简单，其实动态数组没有什么特别复杂地方。我想通过该例说明几个程序员可能犯的错误。程序中声明了两个全程数组并在OnCreate 事件中初始化了第一个数组：</p>
<p>var<br />  Array1, Array2: array of Integer;</p>
<p>procedure TForm1.FormCreate(Sender: TObject);<br />begin<br />  // allocate<br />  SetLength (Array1, 100);<br />end;<br />这样就把数组所有值设置为0。完成这段代码你马上就能读写数组元素的值，而不用害怕内存出错，当然条件是你没有试图访问超过数组上界的元素。为了更好地初始化，程序中添加了一个按钮，执行数组元素赋值操作：</p>
<p>procedure TForm1.btnFillClick(Sender: TObject);<br />var<br />  I: Integer;<br />begin<br />  for I := Low (Array1) to High (Array1) do<br />    Array1 [I] := I;<br />end;<br />Grow 按钮用于修改数组大小，但并不影响数组内容。单击Grow 按钮后，你可以用Get value按钮进行检验：</p>
<p>procedure TForm1.btnGrowClick(Sender: TObject);<br />begin<br />  // grow keeping existing values<br />  SetLength (Array1, 200);<br />end;</p>
<p>procedure TForm1.btnGetClick(Sender: TObject);<br />begin<br />  // extract<br />  Caption := IntToStr (Array1 [99]);<br />end;<br />Alias 按钮的OnClick 事件代码稍复杂些，程序通过 := 算子把一个数组拷贝给另一个数组，从而有效地创建了一个别名（一个新变量，但引用内存中同一数组）。从中可见，如果你改变了其中一个数组，那么另一个同样也会改变，因为它们指向同一个内存区：</p>
<p>procedure TForm1.btnAliasClick(Sender: TObject);<br />begin<br />  // alias<br />  Array2 := Array1;<br />  // change one (both change)<br />  Array2 [99] := 1000;<br />  // show the other<br />  Caption := IntToStr (Array1 [99]);<br />在btnAliasClick 事件中增加了两部分操作内容。第一部分是数组等同测试，不过并不是测试实际的数组元素，而是测试数组所引用的内存区，检测变量是不是内存中同一数组的两个别名：</p>
<p>procedure TForm1.btnAliasClick(Sender: TObject);<br />begin<br />  ...<br />  if Array1 = Array2 then<br />    Beep;<br />  // truncate first array<br />  Array1 := Copy (Array2, 0, 10);<br />end;<br />btnAliasClick 事件的第二部分内容是调用Copy 函数。该函数不仅把数据从一个数组移到另一个数组，而且用函数创建的新数组取代第一个数组，结果变量Array1 所引用的是11个元素的数组，因此，按Get value 和Set value 按钮将产生一个内存错误，并且触发一个异常（除非你把范围检查range-checking 选项关掉，这种情况下，错误仍在但屏幕上 不会显示异常）。虽然如此，Fill 按钮仍能正常工作，因为需要修改的数组元素由数组当前的下标范围确定。</p>
<p>自从有了动态数组，链表除了在教科书里出现外，已经很少在实际编程中被使用了，事实也是如此，数组的确比传统链表快得多,而且也方便的多。</p>
<p>从 Delphi4起，开始了内建各种类型的动态数组支持。但是，对我们来说动态数组支持似乎做的不够彻底，因为Delphi竟然连删除、插入、移动连续元素的函数都没有提供，让人使用起来总觉得不够爽！！！ J 。作为一名程序员，我们当然要有自己解决问题的能力，下面就让我们简单介绍一下Delphi 下的动态数组。</p>
<p>在Delphi中，数组类型有静态数组（a : array[0..1024] of integer）、动态数组（var a : array of integer）、指针数组（即指向静态数组的指针）和开放数组（仅用于参数传递）。静态数组、指针数组有速度快的好处，动态数组有大小可变的优势，权衡之下就有了折衷的办法，那就是定义的动态数组在必要时转换为指针。</p>
<p>动态数组声明之后，只有下面几个函数可供操作：</p>
<p>1．  设置数组大小，可以任意缩减或增加数组大小</p>
<p>Procedure SetLength(var S ; NewLength : integer);</p>
<p>2．  取出连续元素，复制给另一个数组变量</p>
<p>Function Copy(s;Index,Count : integer) : array ;</p>
<p>3．  取得数组大小及上下限</p>
<p>Function Length(s):integer;</p>
<p>Function High(x):integer;</p>
<p>Function Low(x):integer;</p>
<p>值得注意的是，不加const或var修饰的动态数组会被作为形参传递，而动态数组用const修饰并不意味着你不能修改数组里的元素（不信你可以字自己在程序中试试。还有一点是High函数调用了Length 函数，所以我们在获取数组上限时最好直接用 Length(s) 函数。</p>
<p>动态数组在内存空间中占用4个字节.  动态数组在内存中的分配表如下：</p>
<p>偏移量    内容</p>
<p>-8    32-bit 引用计数</p>
<p>-4    32-bit 数组长度</p>
<p>0..数组长度 * (元素尺寸) - 1   数组元素  元素尺寸=Sizeof(元素类型)</p>
<p>根据上面的分配情况，可以得到如下结果：</p>
<p>如果我们想要清空一个动态数组只需要把&ldquo;数组长度&rdquo;和&ldquo;引用计数&rdquo;清空即可。&rdquo;引用上面的一句话就是：&ldquo;权衡之下就有了折衷的办法，那就是定义的动态数组在必要时转换为指针。&rdquo;下面是清空动态数组的函数：</p>
<p>procedure DynArraySetZero(var A);</p>
<p>var</p>
<p>P: PLongint; //占用4个字节，正好符合 32 位内存排列</p>
<p>begin</p>
<p>P := PLongint(A); // 指向 A 的地址</p>
<p>Dec(P); //P 地址偏移量是 sizeof(A)，指向了数组长度</p>
<p>P^ := 0; // 长度清空</p>
<p>Dec(P); // 指向引用计数</p>
<p>P^ := 0; //计数清空。</p>
<p>end;</p>
<p>上面的函数就这么简单，而且效率也非常高。</p>
<p>下面让我们再来看看怎样删除动态数组中的元素,函数体如下：</p>
<p>{************************************</p>
<p>A 变量类型  ， elSize = SizeOf(A)</p>
<p>index 开始删除的位置索引 ，Count 删除的数量</p>
<p>****************************************}</p>
<p>procedure DynArrayDelete(var A; elSize: Longint; index, Count: Integer);</p>
<p>var</p>
<p>len, MaxDelete: Integer;</p>
<p>P : PLongint; //4 个字节的长整形指针</p>
<p>begin</p>
<p>P := PLongint(A);// 取的 A 的地址</p>
<p>if P = nil then</p>
<p>Exit;</p>
<p>{</p>
<p>下面这句完全等同于 Dec(P) ; len := P^  因为 Dec(P) = Pchar(P) &ndash; 4  同样是移动4 字节的偏移量，只不过后者按字节来移动  }</p>
<p>len := PLongint(PChar(P) - 4)^; // 变量的长度 ，偏移量 -4</p>
<p>if index &gt;= len then //要删除的位置超出范围，退出</p>
<p>Exit;</p>
<p>MaxDelete := len - index; // 最多删除的数量</p>
<p>Count := Min(Count, MaxDelete); // 取得一个较小值</p>
<p>if Count = 0 then // 不要求删除</p>
<p>Exit;</p>
<p>Dec(len, Count);// 移动到要删除的位置</p>
<p>MoveMemory(PChar(P)+index*elSize , PChar(P)+(index + Count)*elSize , (len-index)*elSize); //移动内存</p>
<p>Dec(P);  //移出 &ldquo;数组长度&rdquo;位置</p>
<p>Dec(P);  //移出&ldquo;引用计数&rdquo; 位置</p>
<p>//重新再分配调整内存,len 新的长度. Sizeof(Longint) * 2 = 2*Dec(P)</p>
<p>ReallocMem(P, len * elSize + Sizeof(Longint) * 2);</p>
<p>Inc(P); // 指向数组长度</p>
<p>P^ := len; // new length</p>
<p>Inc(P); // 指向数组元素，开始的位置</p>
<p>PLongint(A) := P;</p>
<p>end;</p>
<p>对上面的例子，我们需要注意的是 elSize 参数 ，它必须是 SizeOf(DyArray_Name),表示元素所占用的字节数。</p>
<p>相信看了上面的例子后，对于动态数组的拷贝，移动想必也可以自己实现了吧 J</p>
<p>后续：</p>
<p>其实,Delphi 对许多类型的内存分配都很相似，比如 string 类型，其实它和动态数组是很相似的，我们完全可以把它拿来当成动态数组。实质上 string 是 Pchar 的简易版本。不管怎么说，了解一些内存的分配对我们这些开发人员来说还是有一些好处的。</p>
<p>http://blog.csdn.net/procedure1984/article/details/3297092</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlj6jk9.html">asp&period;net中用cookie记住密码上次不用登陆</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93j3lr8.html">springMVC学习之url重写：urlrewrite with tuckey UrlRewriteFilter</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96lkxy9.html">反射实现 AOP 动态代理模式&lpar;Spring AOP 的实现 原理&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k6235q.html">第一个java程序hello world</a>
		</li>
						<li><a href="https://www.batexi.com/a/96omlm49.html">spring mvc 基于注解的使用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1dg379.html">C&num; WinForm实现控件拖动实例介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn1lke8.html">T-SQL存储过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwwjvj9.html">window、view相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj3w379.html">&num;565&period; 「LibreOJ Round &num;10」mathematican 的二进制（期望 &plus; 分治NTT）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwddxj9.html">go 命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wvxjrq.html">Go语言为何说它优雅？-- Golang中的几个常用初始化设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/960dz6y9.html">python基础之 面向对象之反射</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25lnwwq.html">django中表单处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5oe6eq.html">IDFA</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnv3lgq.html">源码分析HotSpot GC过程&lpar;三&rpar;：TenuredGeneration的GC过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o45g71q.html">localforage  对不同浏览器 使用不同的缓存策略 &comma; 大大提高了性能 &comma;IndexedDB，WebSQL 和 localStorage 三种存储模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql15w0k9.html">django中的ajax组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp5ple9.html">Python之函数&mdash;&mdash;内置函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e2e5x9.html">彻底弄懂HTTP缓存机制及原理（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o42n1eq.html">CentOS7无法使用tab补全功能？？</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8okxdxx9.html">CSS3 旋转3D立方体</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o65ln9.html">PHP删除HTMl标签</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmz5yk9.html">输出多行字符的一个简单JAVA小程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdj1dd8.html">webpack和webpack-dev-server的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1pj2x9.html">论try&sol;catch的重要性，我们经常遇到代码出现无法调试的错误，程序退出的时候崩溃。这跟我们代码日常保护的习惯息息相关。</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde6z409.html">BZOJ 1492&colon; &lbrack;NOI2007&rsqb;货币兑换Cash&lpar; dp &plus; 平衡树 &rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1pr7x9.html">《Pointers On C》读书笔记&lpar;第二章 基本概念&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydeovjq.html">Debian下自动备份文件并上传到远程FTP服务器且删除指定日期前的备份Shell脚本</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0yxlgq.html">常用CSS HACK</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4ye61eq.html">Pro&sol;E 5&period;0安装图解教程（也适用于Creo Elements&sol;Pro 5&period;0）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
